program fxpc;

{$APPTYPE CONSOLE}

uses
  SysUtils,classes,fxpascal;

var
 definelist:TStringList;

procedure CompileFile(const filename:string);
var
 st:TFileStream;
 s,r:string;
 warnings:TStringList;
 i:integer;
begin
if not FileExists(filename) then
begin
 writeln(filename+' not found');
 exit;
end;
writeln('Compiling ',filename);
st:=TFileStream.Create(filename,fmopenread);
try
 setlength(s,st.size);
 st.ReadBuffer(s[1],st.size);
finally
 FreeAndNil(st);
end;
warnings:=TStringList.Create;
try
 r:=CompileProgram(s,nil,warnings,definelist);
except
 writeln(Exception(ExceptObject).message);
 writeln;
 exit;
end;

for i:=0 to warnings.count-1 do
 writeln(warnings[i]);
warnings.free;
try
 st:=TFileStream.Create(ChangeFileExt(filename,'.asm'),fmcreate);
 st.WriteBuffer(r[1],length(r));
finally
 st.free;
end;
end;

procedure CompileFileList(const pattern:string);
var
 r:TSearchRec;
 i:integer;
 path:string;
begin
path:=ExtractFilePath(pattern);
i:=FindFirst(pattern,faAnyFile,r);
if i<>0 then
 writeln(pattern+' not found');
while i=0 do
begin
 if copy(r.Name,1,1)<>'.' then CompileFile(path+r.Name);
 i:=FindNext(r);
end;
FindClose(r);
end;

var
 i:integer;
begin
definelist:=TStringList.Create;
writeln;
writeln('fxPascal Shader Compiler 0.45');
writeln;

for i:=1 to ParamCount do
begin
 if copy(paramstr(i),1,1)='-' then
  definelist.Add(ParamStr(i))
 else
  CompileFileList(ParamStr(i));
end;
definelist.free;
end.
